import { useEffect } from 'react';
import { useAppSelector } from '@/redux/hooks/useAppSelector';
import { modelsDataSelector } from '@/redux/models/models.selectors';
import { useAppDispatch } from '@/redux/hooks/useAppDispatch';
import { getCompartmentPathways } from '@/redux/compartmentPathways/compartmentPathways.thunks';
import { Annotations } from '../Annotations';
import { Types } from './Types';
import { IncludedCompartmentPathways } from './IncludedCompartmentPathways ';
import { ExcludedCompartmentPathways } from './ExcludedCompartmentPathways';
import { Columns } from './Columns';
import { getModelsIds } from './Elements.utils';

export const Elements = (): React.ReactNode => {
  const models = useAppSelector(modelsDataSelector);
  const dispatch = useAppDispatch();

  useEffect(() => {
    const modelsIds = getModelsIds(models);
    dispatch(getCompartmentPathways(modelsIds));
  }, [dispatch, models]);

  return (
    <div data-testid="elements-tab">
      <Types />
      <Columns />
      <Annotations />
      <IncludedCompartmentPathways />
      <ExcludedCompartmentPathways />
    </div>
  );
};
