/* eslint-disable no-magic-numbers */
import { useAppSelector } from '@/redux/hooks/useAppSelector';
import {
  compartmentPathwaysDataSelector,
  loadingCompartmentPathwaysSelector,
} from '@/redux/compartmentPathways/compartmentPathways.selectors';
import { CheckboxFilter } from '../../CheckboxFilter';
import { CollapsibleSection } from '../../CollapsibleSection';
import { getCompartmentPathwaysCheckboxElements } from '../Elements.utils';

export const ExcludedCompartmentPathways = (): React.ReactNode => {
  const loadingCompartmentPathways = useAppSelector(loadingCompartmentPathwaysSelector);
  const isPending = loadingCompartmentPathways === 'pending';
  const compartmentPathways = useAppSelector(compartmentPathwaysDataSelector);
  const checkboxElements = getCompartmentPathwaysCheckboxElements(compartmentPathways);
  const isCheckboxFilterVisible = !isPending && checkboxElements && checkboxElements.length > 0;

  return (
    <CollapsibleSection title="Select excluded compartment / pathways">
      {isPending && <p>Loading...</p>}
      {isCheckboxFilterVisible && <CheckboxFilter options={checkboxElements} />}
    </CollapsibleSection>
  );
};
