/* eslint-disable no-magic-numbers */
import {
  compartmentPathwaysDataSelector,
  loadingCompartmentPathwaysSelector,
} from '@/redux/compartmentPathways/compartmentPathways.selectors';
import { useAppSelector } from '@/redux/hooks/useAppSelector';
import { CheckboxFilter } from '../../CheckboxFilter';
import { CollapsibleSection } from '../../CollapsibleSection';
import { getCompartmentPathwaysCheckboxElements } from '../Elements.utils';

export const IncludedCompartmentPathways = (): React.ReactNode => {
  const loadingCompartmentPathways = useAppSelector(loadingCompartmentPathwaysSelector);
  const isPending = loadingCompartmentPathways === 'pending';
  const compartmentPathways = useAppSelector(compartmentPathwaysDataSelector);
  const checkboxElements = getCompartmentPathwaysCheckboxElements(compartmentPathways);

  return (
    <CollapsibleSection title="Select included compartment / pathways">
      {isPending && <p>Loading...</p>}
      {!isPending && checkboxElements && checkboxElements.length > 0 && (
        <CheckboxFilter options={checkboxElements} />
      )}
    </CollapsibleSection>
  );
};
