import { elementTypesSelector } from '@/redux/configuration/configuration.selectors';
import { useAppSelector } from '@/redux/hooks/useAppSelector';
import { getCheckboxElements } from './Types.utils';
import { CheckboxFilter } from '../../CheckboxFilter';
import { CollapsibleSection } from '../../CollapsibleSection';

export const Types = (): React.ReactNode => {
  const elementTypes = useAppSelector(elementTypesSelector);
  const checkboxElements = getCheckboxElements(elementTypes);

  return (
    <CollapsibleSection title="Select types">
      {checkboxElements && <CheckboxFilter options={checkboxElements} isSearchEnabled={false} />}
    </CollapsibleSection>
  );
};
