import { QueryDataParams } from '@/types/query';
import { createSelector } from '@reduxjs/toolkit';
import { ZERO } from '@/constants/common';
import { mapDataSelector } from '../map/map.selectors';
import { perfectMatchSelector, searchValueSelector } from '../search/search.selectors';
import { activeOverlaysIdSelector } from '../overlayBioEntity/overlayBioEntity.selector';

export const queryDataParamsSelector = createSelector(
  searchValueSelector,
  perfectMatchSelector,
  mapDataSelector,
  activeOverlaysIdSelector,
  (
    searchValue,
    perfectMatch,
    { modelId, backgroundId, position },
    activeOverlaysId,
  ): QueryDataParams => {
    const queryDataParams: QueryDataParams = {
      searchValue: searchValue.join(';'),
      perfectMatch,
      modelId,
      backgroundId,
      ...position.last,
    };

    if (activeOverlaysId.length > ZERO) {
      queryDataParams.overlaysId = activeOverlaysId.join(',');
    }

    return queryDataParams;
  },
);
