import { Color } from './models';

export type OverlayBioEntityRenderType = 'line' | 'rectangle';

export type OverlayBioEntityRender = {
  id: number;
  modelId: number;
  /** bottom left corner of whole element, Xmin */
  x1: number;
  /** bottom left corner of whole element, Ymin */
  y1: number;
  /** top righ corner of whole element, xMax */
  x2: number;
  /** top righ corner of whole element, yMax */
  y2: number;
  width: number;
  height: number;
  value: number | null;
  overlayId: number;
  color: Color | null;
  type: OverlayBioEntityRenderType;
};

export interface OverlayReactionCoords {
  x1: number;
  x2: number;
  y1: number;
  y2: number;
  id: number;
  height: number;
  width: number;
}
